PMLPF_class {
	*ar { arg in, fc=380, mul=1, add=0;
		var k, b0, b1, b2, a0, a1, a2, fs, k_squared, k_twice;
		fs  = SampleRate.ir;
		k = tan(pi*fc/fs);
		k_squared = k.squared;
		k_twice = k*2;
		a0 = k_squared/(k_squared+k_twice+1);
		a1 = 2 * a0;
		a2 = a0;
		b0 = 1;
		b1 = (2*(k_squared-1))/(k_squared+k_twice+1);
		b2 = (k_squared-k_twice+1)/(k_squared+k_twice+1);
		^SOS.ar(in, a0, a1, a2, b1.neg, b2.neg, mul, add)
	}
}		
		
// the output of this filter is phase inverted to match in phase
// with PMLPF	at the cross-over frequency. JP
PMHPF_class {
	*ar { arg in, fc=380, mul=1, add=0;
		var k, b0, b1, b2, a0, a1, a2, fs, k_squared, k_twice;
		fs  = SampleRate.ir;
		k = tan(pi*fc/fs);
		k_squared = k.squared;
		k_twice = k*2;
		a0 = 1/(k_squared+k_twice+1);
		a1 = -2  * a0;
		a2 = a0;
		b0 = 1;
		b1 = (2*(k_squared-1))/(k_squared+k_twice+1);
		b2 = (k_squared-k_twice+1)/(k_squared+k_twice+1);
		^SOS.ar(in, a0, a1, a2, b1.neg, b2.neg, mul, add).neg
	}
}

//	Near Field Compensation filter
// this is just a one-pole highpass filter
NFC_class {	
	*ar { arg in, distance, mul=1, add=0;
	var d, c, k, b0, b1, a0, a1, fc, fs;
	// transition frecuency for near-field compensation
	// is calculated as follows:
	// distance from center to speakers in meters 
	d = distance;
	// speed of sound in m/s
	c = 340;
	// transition frequency
	fc = c/(2pi * d);
	// sampling rate
	fs  = SampleRate.ir;
	
	k = tan(pi*fc/fs);
	
	a0 = (k+1).reciprocal;
	a1 = a0.neg;
	b0 = 1;
	b1 = (k-1)*a0;
	^FOS.ar(in, a0, a1, b1.neg, mul, add)
	}
}	
		

		